org.apache.xalan.transformer

## Class TransformerImpl

- java.lang.Object
- - javax.xml.transform.Transformer
  - - org.apache.xalan.transformer.TransformerImpl

All Implemented Interfaces:
  java.lang.Runnable, DTMWSFilter, SerializerTrace, ExtensionsProvider

    public class TransformerImpl
    extends Transformer
    implements java.lang.Runnable, DTMWSFilter, ExtensionsProvider, SerializerTrace

This class implements the `Transformer` interface, and is the core representation of the transformation execution.

Usage:
  **For advanced use only**

### Field Summary

### Fields inherited from interface org.apache.xml.dtm.DTMWSFilter

`INHERIT, NOTSTRIP, STRIP`

### Fields inherited from interface org.apache.xml.serializer.SerializerTrace

`EVENTTYPE_CDATA, EVENTTYPE_CHARACTERS, EVENTTYPE_COMMENT, EVENTTYPE_ENDDOCUMENT, EVENTTYPE_ENDELEMENT, EVENTTYPE_ENTITYREF, EVENTTYPE_IGNORABLEWHITESPACE, EVENTTYPE_OUTPUT_CHARACTERS, EVENTTYPE_OUTPUT_PSEUDO_CHARACTERS, EVENTTYPE_PI, EVENTTYPE_STARTDOCUMENT, EVENTTYPE_STARTELEMENT`

### Constructor Summary

Constructors
Constructor and Description
`TransformerImpl(StylesheetRoot stylesheet)` Construct a TransformerImpl.

### Method Summary

Methods
`boolean` `applyTemplateToNode(ElemTemplateElement xslInstruction, ElemTemplate template, int child)` Given an element and mode, find the corresponding template and process the contents.
`void` `clearParameters()` Reset the parameters to a null list.
`SerializationHandler` `createSerializationHandler(Result outputTarget)` Create a result ContentHandler from a Result object, based on the current OutputProperties.
`SerializationHandler` `createSerializationHandler(Result outputTarget, OutputProperties format)` Create a ContentHandler from a Result object and an OutputProperties.
`boolean` `currentFuncResultSeen()` Determines whether an EXSLT `func:result` instruction has been executed for the currently active EXSLT `func:function`.
`boolean` `currentTemplateRuleIsNull()` Tell if the current template rule is null, i.e. if we are directly within an apply-templates.
`boolean` `elementAvailable(java.lang.String ns, java.lang.String elemName)` Is the extension element available?
`void` `executeChildTemplates(ElemTemplateElement elem, boolean shouldAddAttrs)` Execute each of the children of a template element.
`void` `executeChildTemplates(ElemTemplateElement elem, ContentHandler handler)` Execute each of the children of a template element.
`void` `executeChildTemplates(ElemTemplateElement elem, Node context, QName mode, ContentHandler handler)` Execute each of the children of a template element.
`void` `executeFromSnapshot(TransformSnapshot ts)` Deprecated. This is an internal tooling API that nobody seems to be using
`java.lang.Object` `extFunction(FuncExtFunction extFunction, java.util.Vector argVec)` Execute the extension function.
`java.lang.Object` `extFunction(java.lang.String ns, java.lang.String funcName, java.util.Vector argVec, java.lang.Object methodKey)` Execute the extension function.
`void` `fireGenerateEvent(int eventType)` Fire off startDocument, endDocument events.
`void` `fireGenerateEvent(int eventType, char[] ch, int start, int length)` Fire off characters, cdate events.
`void` `fireGenerateEvent(int eventType, java.lang.String data)` Fire off comment and entity ref events.
`void` `fireGenerateEvent(int eventType, java.lang.String name, Attributes atts)` Fire off startElement, endElement events.
`void` `fireGenerateEvent(int eventType, java.lang.String name, java.lang.String data)` Fire off processingInstruction events.
`boolean` `functionAvailable(java.lang.String ns, java.lang.String funcName)` Is the extension function available?
`java.lang.String` `getBaseURLOfSource()` Get the base URL of the source.
`ContentHandler` `getContentHandler()` Get the content event handler.
`DTMIterator` `getContextNodeList()` Get the current context node list.
`CountersTable` `getCountersTable()` Get the table of counters, for optimized xsl:number support.
`ElemTemplateElement` `getCurrentElement()` Retrieves the current ElemTemplateElement that is being executed.
`int` `getCurrentNode()` This method retrieves the current context node in the source tree.
`ElemTemplate` `getCurrentTemplate()` This method retrieves the xsl:template that is in effect, which may be a matched template or a named template.
`ObjectStack` `getCurrentTemplateElements()` Get the count of how many elements are active.
`int` `getCurrentTemplateElementsCount()` Get the count of how many elements are active.
`boolean` `getDebug()`
`java.util.Vector` `getElementCallstack()` Get the stack of ElemTemplateElements.
`ErrorListener` `getErrorListener()` Get the current error event handler.
`java.lang.Exception` `getExceptionThrown()` Get the exception thrown by the secondary thread (normally the transform thread).
`ExtensionsTable` `getExtensionsTable()` Get the extensions table object.
`boolean` `getFeature(java.lang.String name)` Look up the value of a feature.
`boolean` `getIncremental()`
`ContentHandler` `getInputContentHandler()` Get a SAX2 ContentHandler for the input.
`ContentHandler` `getInputContentHandler(boolean doDocFrag)` Get a SAX2 ContentHandler for the input.
`DeclHandler` `getInputDeclHandler()` Get a SAX2 DeclHandler for the input.
`LexicalHandler` `getInputLexicalHandler()` Get a SAX2 LexicalHandler for the input.
`KeyManager` `getKeyManager()` Get the KeyManager object.
`int` `getMatchedNode()` Retrieves the node in the source tree that matched the template obtained via getMatchedTemplate().
`ElemTemplate` `getMatchedTemplate()` This method retrieves the xsl:template that was matched.
`QName` `getMode()` NEEDSDOC Method getMode NEEDSDOC (getMode) @return
`MsgMgr` `getMsgMgr()` Return the message manager.
`boolean` `getOptimize()`
`OutputProperties` `getOutputFormat()` Get the output properties used for the transformation.
`java.util.Properties` `getOutputProperties()` Get a copy of the output properties for the transformation.
`java.lang.String` `getOutputProperty(java.lang.String qnameString)` Get an output property that is in effect for the transformation.
`java.lang.String` `getOutputPropertyNoDefault(java.lang.String qnameString)` Get the value of a property, without using the default properties.
`Result` `getOutputTarget()` Get the original output target.
`java.lang.Object` `getParameter(java.lang.String name)` Get a parameter that was explicitly set with setParameter or setParameters.
`boolean` `getProperty(java.lang.String property)` `getProperty` returns the current setting of the property described by the `property` argument.
`boolean` `getQuietConflictWarnings()` Get quietConflictWarnings property.
`int` `getRecursionLimit()` Get the recursion limit.
`SerializationHandler` `getResultTreeHandler()` Get the SerializationHandler object.
`SerializationHandler` `getSerializationHandler()` Get the SerializationHandler object.
`short` `getShouldStripSpace(int elementHandle, DTM dtm)` Test whether whitespace-only text nodes are visible in the logical view of `DTM`.
`TransformSnapshot` `getSnapshot()` Deprecated. This is an internal tooling API that nobody seems to be using
`boolean` `getSource_location()`
`StackGuard` `getStackGuard()` Get the object used to guard the stack from recursion.
`ObjectPool` `getStringWriterPool()` Get the StringWriter pool, so that StringWriter objects may be reused.
`StylesheetRoot` `getStylesheet()` Get the current stylesheet for this processor.
`java.util.Vector` `getTemplateCallstack()` Get the call stack of xsl:template elements.
`TraceManager` `getTraceManager()` Get an instance of the trace manager for this transformation.
`Transformer` `getTransformer()` Get the TrAX Transformer object in effect.
`java.lang.Thread` `getTransformThread()` Get the thread that the transform process is on.
`URIResolver` `getURIResolver()` Get an object that will be used to resolve URIs used in document(), etc.
`XPathContext` `getXPathContext()` Get the XPath context associated with this transformer.
`boolean` `hasTraceListeners()` Tell if trace listeners are present.
`boolean` `hasTransformThreadErrorCatcher()` Return true if the transform was initiated from the transform method, otherwise it was probably done from a pure parse events.
`void` `init(ToXMLSAXHandler h, Transformer transformer, ContentHandler realHandler)` Initializer method.
`boolean` `isParserEventsOnMain()` Get true if the parser events should be on the main thread, false if not.
`boolean` `isRecursiveAttrSet(ElemAttributeSet attrSet)` Check to see if this is a recursive attribute definition.
`boolean` `isTransformDone()` Tell if the transform method is completed.
`java.lang.Object` `popCurrentFuncResult()` Pops the result of the currently active EXSLT `func:function`.
`void` `popCurrentMatched()` Pop the elements that were pushed via pushPairCurrentMatched.
`void` `popCurrentTemplateRuleIsNull()` Push true if the current template rule is null, false otherwise.
`void` `popElemAttributeSet()` Pop the current executing attribute set.
`void` `popElemTemplateElement()` Pop the current template element.
`void` `popMode()` NEEDSDOC Method popMode
`java.util.Vector` `processSortKeys(ElemForEach foreach, int sourceNodeContext)` Get the keys for the xsl:sort elements.
`void` `pushCurrentFuncResult(java.lang.Object val)` Push a funcion result for the currently active EXSLT `func:function`.
`void` `pushCurrentTemplateRuleIsNull(boolean b)` Push true if the current template rule is null, false otherwise.
`void` `pushElemAttributeSet(ElemAttributeSet attrSet)` Push an executing attribute set, so we can check for recursive attribute definitions.
`void` `pushElemTemplateElement(ElemTemplateElement elem)` Push the current template element.
`void` `pushMode(QName mode)` NEEDSDOC Method pushMode NEEDSDOC @param mode
`void` `pushPairCurrentMatched(ElemTemplateElement template, int child)` Push both the current xsl:template or xsl:for-each onto the stack, along with the child node that was matched.
`void` `reset()` Reset the state.
`void` `resetToStylesheet(TransformSnapshot ts)` Deprecated. This is an internal tooling API that nobody seems to be using
`void` `run()` Run the transform thread.
`void` `runTransformThread()` Called by this.transform() if isParserEventsOnMain()==false.
`void` `runTransformThread(int priority)` Called by SourceTreeHandler to start the transformation in a separate thread NEEDSDOC @param priority
`static void` `runTransformThread(java.lang.Runnable runnable)` Called by CoRoutineSAXParser.
`void` `setBaseURLOfSource(java.lang.String base)` Get the base URL of the source.
`void` `setContentHandler(ContentHandler handler)` Set the content event handler.
`void` `setCurrentElement(ElemTemplateElement e)` Set the top of the current template elements stack.
`void` `setDebug(boolean b)`
`void` `setErrorListener(ErrorListener listener)` Set the error event listener.
`void` `setExceptionThrown(java.lang.Exception e)` Set the exception thrown by the secondary thread (normally the transform thread).
`void` `setIsTransformDone(boolean done)` Set if the transform method is completed.
`void` `setOutputFormat(OutputProperties oformat)` Set the output properties for the transformation.
`void` `setOutputProperties(java.util.Properties oformat)` Set the output properties for the transformation.
`void` `setOutputProperty(java.lang.String name, java.lang.String value)` This method is used to set or override the value of the effective xsl:output attribute values specified in the stylesheet.
`void` `setOutputTarget(Result outputTarget)` Set the original output target.
`void` `setParameter(java.lang.String name, java.lang.Object value)` Set a parameter for the transformation.
`void` `setParameter(java.lang.String name, java.lang.String namespace, java.lang.Object value)` Set a parameter for the templates.
`void` `setParameters(java.util.Properties params)` Set a bag of parameters for the transformation.
`void` `setProperty(java.lang.String property, java.lang.Object value)` Set a runtime property for this `TransformerImpl`.
`void` `setQuietConflictWarnings(boolean b)` If the quietConflictWarnings property is set to true, warnings about pattern conflicts won't be printed to the diagnostics stream.
`void` `setRecursionLimit(int limit)` Set the recursion limit.
`void` `setSerializationHandler(SerializationHandler xoh)`
`void` `setShouldReset(boolean shouldReset)` NEEDSDOC Method setShouldReset NEEDSDOC @param shouldReset
`void` `setSourceTreeDocForThread(int doc)` This is just a way to set the document for run().
`void` `setStylesheet(StylesheetRoot stylesheetRoot)` Set the stylesheet for this processor.
`void` `setTransformThread(java.lang.Thread t)` Get the thread that the transform process is on.
`void` `setURIResolver(URIResolver resolver)` Set an object that will be used to resolve URIs used in document(), etc.
`void` `setXMLSource(Source source)` Set the input source for the source tree, which is needed if the parse thread is not the main thread, in order for the parse thread's run method to get to the input source.
`void` `setXPathContext(XPathContext xcontext)` Set the execution context for XPath.
`void` `stopTransformation()` NEEDSDOC Method stopTransformation
`void` `transform(Source source)` Process the source tree to SAX parse events.
`void` `transform(Source source, boolean shouldRelease)` Process the source tree to SAX parse events.
`void` `transform(Source xmlSource, Result outputTarget)` Process the source tree to the output result.
`void` `transform(Source xmlSource, Result outputTarget, boolean shouldRelease)` Process the source tree to the output result.
`void` `transformNode(int node)` Process the source node to the output result, if the processor supports the "http://xml.org/trax/features/dom/input" feature.
`void` `transformNode(int node, Result outputTarget)` Process the source node to the output result, if the processor supports the "http://xml.org/trax/features/dom/input" feature.
`int` `transformToGlobalRTF(ElemTemplateElement templateParent)` Given a stylesheet element, create a result tree fragment from it's contents.
`int` `transformToRTF(ElemTemplateElement templateParent)` Given a stylesheet element, create a result tree fragment from it's contents.
`java.lang.String` `transformToString(ElemTemplateElement elem)` Take the contents of a template element, process it, and convert it to a string.
`void` `waitTransformThread()` Used by SourceTreeHandler to wait until the transform completes

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### TransformerImpl

    public TransformerImpl(StylesheetRoot stylesheet)

Construct a TransformerImpl.

Parameters:
  `stylesheet` - The root of the stylesheet tree.

### Method Detail

#### setShouldReset

    public void setShouldReset(boolean shouldReset)

NEEDSDOC Method setShouldReset NEEDSDOC @param shouldReset

#### getExtensionsTable

    public ExtensionsTable getExtensionsTable()

Get the extensions table object.

Returns:
  The extensions table.

#### functionAvailable

    public boolean functionAvailable(java.lang.String ns,
                            java.lang.String funcName)
                              throws TransformerException

Description copied from interface: `ExtensionsProvider`
Is the extension function available?

Specified by:
  `functionAvailable` in interface `ExtensionsProvider`
Throws:
  `TransformerException`

#### elementAvailable

    public boolean elementAvailable(java.lang.String ns,
                           java.lang.String elemName)
                             throws TransformerException

Description copied from interface: `ExtensionsProvider`
Is the extension element available?

Specified by:
  `elementAvailable` in interface `ExtensionsProvider`
Throws:
  `TransformerException`

#### extFunction

    public java.lang.Object extFunction(java.lang.String ns,
                               java.lang.String funcName,
                               java.util.Vector argVec,
                               java.lang.Object methodKey)
                                 throws TransformerException

Description copied from interface: `ExtensionsProvider`
Execute the extension function.

Specified by:
  `extFunction` in interface `ExtensionsProvider`
Throws:
  `TransformerException`

#### extFunction

    public java.lang.Object extFunction(FuncExtFunction extFunction,
                               java.util.Vector argVec)
                                 throws TransformerException

Description copied from interface: `ExtensionsProvider`
Execute the extension function.

Specified by:
  `extFunction` in interface `ExtensionsProvider`
Throws:
  `TransformerException`

#### reset

    public void reset()

Reset the state. This needs to be called after a process() call is invoked, if the processor is to be used again.

Overrides:
  `reset` in class `Transformer`

#### getProperty

    public boolean getProperty(java.lang.String property)

`getProperty` returns the current setting of the property described by the `property` argument. %REVIEW% Obsolete now that source_location is handled in the TransformerFactory?

Parameters:
  `property` - a `String` value
Returns:
  a `boolean` value

#### setProperty

    public void setProperty(java.lang.String property,
                   java.lang.Object value)

Set a runtime property for this `TransformerImpl`. %REVIEW% Obsolete now that source_location is handled in the TransformerFactory?

Parameters:
  `property` - a `String` value
  `value` - an `Object` value

#### isParserEventsOnMain

    public boolean isParserEventsOnMain()

Get true if the parser events should be on the main thread, false if not. Experimental. Can not be set right now.

Returns:
  true if the parser events should be on the main thread, false if not.
Usage:
  **Experimental**

#### getTransformThread

    public java.lang.Thread getTransformThread()

Get the thread that the transform process is on.

Returns:
  The thread that the transform process is on, or null.
Usage:
  **For internal use only**

#### setTransformThread

    public void setTransformThread(java.lang.Thread t)

Get the thread that the transform process is on.

Parameters:
  `t` - The transform thread, may be null.
Usage:
  **For internal use only**

#### hasTransformThreadErrorCatcher

    public boolean hasTransformThreadErrorCatcher()

Return true if the transform was initiated from the transform method, otherwise it was probably done from a pure parse events. NEEDSDOC ($objectName$) @return

#### transform

    public void transform(Source source)
                   throws TransformerException

Process the source tree to SAX parse events.

Parameters:
  `source` - The input for the source tree.
Throws:
  `TransformerException`

#### transform

    public void transform(Source source,
                 boolean shouldRelease)
                   throws TransformerException

Process the source tree to SAX parse events.

Parameters:
  `source` - The input for the source tree.
  `shouldRelease` - Flag indicating whether to release DTMManager.
Throws:
  `TransformerException`

#### getBaseURLOfSource

    public java.lang.String getBaseURLOfSource()

Get the base URL of the source.

Returns:
  The base URL of the source tree, or null.

#### setBaseURLOfSource

    public void setBaseURLOfSource(java.lang.String base)

Get the base URL of the source. NEEDSDOC @param base

#### getOutputTarget

    public Result getOutputTarget()

Get the original output target.

Returns:
  The Result object used to kick of the transform or null.

#### setOutputTarget

    public void setOutputTarget(Result outputTarget)

Set the original output target. This is useful when using a SAX transform and supplying a ContentHandler or when the URI of the output target should not be the same as the systemID of the original output target. NEEDSDOC @param outputTarget

#### getOutputProperty

    public java.lang.String getOutputProperty(java.lang.String qnameString)
                                       throws java.lang.IllegalArgumentException

Get an output property that is in effect for the transformation. The property specified may be a property that was set with setOutputProperty, or it may be a property specified in the stylesheet. NEEDSDOC @param qnameString

Specified by:
  `getOutputProperty` in class `Transformer`
Parameters:
  `qnameString` - A non-null String that specifies an output property name, which may be namespace qualified.
Returns:
  The string value of the output property, or null if no property was found.
Throws:
  `java.lang.IllegalArgumentException` - If the property is not supported.
See Also:
  `OutputKeys`

#### getOutputPropertyNoDefault

    public java.lang.String getOutputPropertyNoDefault(java.lang.String qnameString)
                                                throws java.lang.IllegalArgumentException

Get the value of a property, without using the default properties. This can be used to test if a property has been explicitly set by the stylesheet or user. NEEDSDOC @param qnameString

Returns:
  The value of the property, or null if not found.
Throws:
  `java.lang.IllegalArgumentException` - If the property is not supported, and is not namespaced.

#### setOutputProperty

    public void setOutputProperty(java.lang.String name,
                         java.lang.String value)
                           throws java.lang.IllegalArgumentException

This method is used to set or override the value of the effective xsl:output attribute values specified in the stylesheet.

The recognized standard output properties are:

- cdata-section-elements
- doctype-system
- doctype-public
- indent
- media-type
- method
- omit-xml-declaration
- standalone
- version

For example:

       tran.setOutputProperty("standalone", "yes");

In the case of the cdata-section-elements property, the value should be a whitespace separated list of element names. The element name is the local name of the element, if it is in no namespace, or, the URI in braces followed immediately by the local name if the element is in that namespace. For example:

     tran.setOutputProperty(
       "cdata-section-elements",
       "elem1 {http://example.uri}elem2 elem3");

The recognized Xalan extension elements are:

- content-handler
- entities
- indent-amount
- line-separator
- omit-meta-tag
- use-url-escaping

These must be in the extension namespace of "http://xml.apache.org/xalan". This is accomplished by putting the namespace URI in braces before the property name, for example:

       tran.setOutputProperty(
         "{http://xml.apache.org/xalan}line-separator" ,
         "\n");

Specified by:
  `setOutputProperty` in class `Transformer`
Parameters:
  `name` - The property name.
  `value` - The requested value for the property.
Throws:
  `java.lang.IllegalArgumentException` - if the property name is not legal.
See Also:
  `OutputKeys`

#### setOutputProperties

    public void setOutputProperties(java.util.Properties oformat)
                             throws java.lang.IllegalArgumentException

Set the output properties for the transformation. These properties will override properties set in the templates with xsl:output.

If argument to this function is null, any properties previously set will be removed.

Specified by:
  `setOutputProperties` in class `Transformer`
Parameters:
  `oformat` - A set of output properties that will be used to override any of the same properties in effect for the transformation.
Throws:
  `java.lang.IllegalArgumentException` - if any of the argument keys are not recognized and are not namespace qualified.
See Also:
  `OutputKeys`, `Properties`

#### getOutputProperties

    public java.util.Properties getOutputProperties()

Get a copy of the output properties for the transformation. These properties will override properties set in the templates with xsl:output.

Note that mutation of the Properties object returned will not effect the properties that the transformation contains.

Specified by:
  `getOutputProperties` in class `Transformer`
Returns:
  A copy of the set of output properties in effect for the next transformation. NEEDSDOC ($objectName$) @return
See Also:
  `OutputKeys`, `Properties`, XSL Transformations (XSLT) Version 1.0

#### createSerializationHandler

    public SerializationHandler createSerializationHandler(Result outputTarget)
                                                    throws TransformerException

Create a result ContentHandler from a Result object, based on the current OutputProperties.

Parameters:
  `outputTarget` - Where the transform result should go, should not be null.
Returns:
  A valid ContentHandler that will create the result tree when it is fed SAX events.
Throws:
  `TransformerException`

#### createSerializationHandler

    public SerializationHandler createSerializationHandler(Result outputTarget,
                                                  OutputProperties format)
                                                    throws TransformerException

Create a ContentHandler from a Result object and an OutputProperties.

Parameters:
  `outputTarget` - Where the transform result should go, should not be null.
  `format` - The OutputProperties object that will contain instructions on how to serialize the output.
Returns:
  A valid ContentHandler that will create the result tree when it is fed SAX events.
Throws:
  `TransformerException`

#### transform

    public void transform(Source xmlSource,
                 Result outputTarget)
                   throws TransformerException

Process the source tree to the output result.

Specified by:
  `transform` in class `Transformer`
Parameters:
  `xmlSource` - The input for the source tree.
  `outputTarget` - The output source target.
Throws:
  `TransformerException`

#### transform

    public void transform(Source xmlSource,
                 Result outputTarget,
                 boolean shouldRelease)
                   throws TransformerException

Process the source tree to the output result.

Parameters:
  `xmlSource` - The input for the source tree.
  `outputTarget` - The output source target.
  `shouldRelease` - Flag indicating whether to release DTMManager.
Throws:
  `TransformerException`

#### transformNode

    public void transformNode(int node,
                     Result outputTarget)
                       throws TransformerException

Process the source node to the output result, if the processor supports the "http://xml.org/trax/features/dom/input" feature. %REVIEW% Do we need a Node version of this?

Parameters:
  `node` - The input source node, which can be any valid DTM node.
  `outputTarget` - The output source target.
Throws:
  `TransformerException`

#### transformNode

    public void transformNode(int node)
                       throws TransformerException

Process the source node to the output result, if the processor supports the "http://xml.org/trax/features/dom/input" feature. %REVIEW% Do we need a Node version of this?

Parameters:
  `node` - The input source node, which can be any valid DTM node.
Throws:
  `TransformerException`

#### getInputContentHandler

    public ContentHandler getInputContentHandler()

Get a SAX2 ContentHandler for the input.

Returns:
  A valid ContentHandler, which should never be null, as long as getFeature("http://xml.org/trax/features/sax/input") returns true.

#### getInputContentHandler

    public ContentHandler getInputContentHandler(boolean doDocFrag)

Get a SAX2 ContentHandler for the input.

Parameters:
  `doDocFrag` - true if a DocumentFragment should be created as the root, rather than a Document.
Returns:
  A valid ContentHandler, which should never be null, as long as getFeature("http://xml.org/trax/features/sax/input") returns true.

#### getInputDeclHandler

    public DeclHandler getInputDeclHandler()

Get a SAX2 DeclHandler for the input.

Returns:
  A valid DeclHandler, which should never be null, as long as getFeature("http://xml.org/trax/features/sax/input") returns true.

#### getInputLexicalHandler

    public LexicalHandler getInputLexicalHandler()

Get a SAX2 LexicalHandler for the input.

Returns:
  A valid LexicalHandler, which should never be null, as long as getFeature("http://xml.org/trax/features/sax/input") returns true.

#### setOutputFormat

    public void setOutputFormat(OutputProperties oformat)

Set the output properties for the transformation. These properties will override properties set in the templates with xsl:output.

Parameters:
  `oformat` - A valid OutputProperties object (which will not be mutated), or null.

#### getOutputFormat

    public OutputProperties getOutputFormat()

Get the output properties used for the transformation.

Returns:
  the output format that was set by the user, otherwise the output format from the stylesheet.

#### setParameter

    public void setParameter(java.lang.String name,
                    java.lang.String namespace,
                    java.lang.Object value)

Set a parameter for the templates.

Parameters:
  `name` - The name of the parameter.
  `namespace` - The namespace of the parameter.
  `value` - The value object. This can be any valid Java object -- it's up to the processor to provide the proper coersion to the object, or simply pass it on for use in extensions.

#### setParameter

    public void setParameter(java.lang.String name,
                    java.lang.Object value)

Set a parameter for the transformation.

Specified by:
  `setParameter` in class `Transformer`
Parameters:
  `name` - The name of the parameter, which may have a namespace URI.
  `value` - The value object. This can be any valid Java object -- it's up to the processor to provide the proper coersion to the object, or simply pass it on for use in extensions.

#### getParameter

    public java.lang.Object getParameter(java.lang.String name)

Get a parameter that was explicitly set with setParameter or setParameters. NEEDSDOC @param name

Specified by:
  `getParameter` in class `Transformer`
Parameters:
  `name` - of `Object` to get
Returns:
  A parameter that has been set with setParameter or setParameters, *not* all the xsl:params on the stylesheet (which require a transformation Source to be evaluated).

#### setParameters

    public void setParameters(java.util.Properties params)

Set a bag of parameters for the transformation. Note that these will not be additive, they will replace the existing set of parameters. NEEDSDOC @param params

#### clearParameters

    public void clearParameters()

Reset the parameters to a null list.

Specified by:
  `clearParameters` in class `Transformer`

#### setURIResolver

    public void setURIResolver(URIResolver resolver)

Set an object that will be used to resolve URIs used in document(), etc.

Specified by:
  `setURIResolver` in class `Transformer`
Parameters:
  `resolver` - An object that implements the URIResolver interface, or null.

#### getURIResolver

    public URIResolver getURIResolver()

Get an object that will be used to resolve URIs used in document(), etc.

Specified by:
  `getURIResolver` in class `Transformer`
Returns:
  An object that implements the URIResolver interface, or null.

#### setContentHandler

    public void setContentHandler(ContentHandler handler)

Set the content event handler. NEEDSDOC @param handler

Throws:
  `java.lang.NullPointerException` - If the handler is null.
See Also:
  `XMLReader.setContentHandler(org.xml.sax.ContentHandler)`

#### getContentHandler

    public ContentHandler getContentHandler()

Get the content event handler.

Returns:
  The current content handler, or null if none was set.
See Also:
  `XMLReader.getContentHandler()`

#### transformToRTF

    public int transformToRTF(ElemTemplateElement templateParent)
                       throws TransformerException

Given a stylesheet element, create a result tree fragment from it's contents. The fragment will be built within the shared RTF DTM system used as a variable stack.

Parameters:
  `templateParent` - The template element that holds the fragment.
Returns:
  the NodeHandle for the root node of the resulting RTF.
Throws:
  `TransformerException`
Usage:
  **For advanced use only**

#### transformToGlobalRTF

    public int transformToGlobalRTF(ElemTemplateElement templateParent)
                             throws TransformerException

Given a stylesheet element, create a result tree fragment from it's contents. The fragment will also use the shared DTM system, but will obtain its space from the global variable pool rather than the dynamic variable stack. This allows late binding of XUnresolvedVariables without the risk that their content will be discarded when the variable stack is popped.

Parameters:
  `templateParent` - The template element that holds the fragment.
Returns:
  the NodeHandle for the root node of the resulting RTF.
Throws:
  `TransformerException`
Usage:
  **For advanced use only**

#### getStringWriterPool

    public ObjectPool getStringWriterPool()

Get the StringWriter pool, so that StringWriter objects may be reused.

Returns:
  The string writer pool, not null.
Usage:
  **For internal use only**

#### transformToString

    public java.lang.String transformToString(ElemTemplateElement elem)
                                       throws TransformerException

Take the contents of a template element, process it, and convert it to a string.

Parameters:
  `elem` - The parent element whose children will be output as a string.
Returns:
  The stringized result of executing the elements children.
Throws:
  `TransformerException`
Usage:
  **For advanced use only**

#### applyTemplateToNode

    public boolean applyTemplateToNode(ElemTemplateElement xslInstruction,
                              ElemTemplate template,
                              int child)
                                throws TransformerException

Given an element and mode, find the corresponding template and process the contents.

Parameters:
  `xslInstruction` - The calling element.
  `template` - The template to use if xsl:for-each, current template for apply-imports, or null.
  `child` - The source context node.
Returns:
  true if applied a template, false if not.
Throws:
  `TransformerException`
Usage:
  **For advanced use only**

#### executeChildTemplates

    public void executeChildTemplates(ElemTemplateElement elem,
                             Node context,
                             QName mode,
                             ContentHandler handler)
                               throws TransformerException

Execute each of the children of a template element. This method is only for extension use.

Parameters:
  `elem` - The ElemTemplateElement that contains the children that should execute. NEEDSDOC @param context
  `mode` - The current mode.
  `handler` - The ContentHandler to where the result events should be fed.
Throws:
  `TransformerException`
Usage:
  **For advanced use only**

#### executeChildTemplates

    public void executeChildTemplates(ElemTemplateElement elem,
                             boolean shouldAddAttrs)
                               throws TransformerException

Execute each of the children of a template element.

Parameters:
  `elem` - The ElemTemplateElement that contains the children that should execute.
  `shouldAddAttrs` - true if xsl:attributes should be executed.
Throws:
  `TransformerException`
Usage:
  **For advanced use only**

#### executeChildTemplates

    public void executeChildTemplates(ElemTemplateElement elem,
                             ContentHandler handler)
                               throws TransformerException

Execute each of the children of a template element.

Parameters:
  `elem` - The ElemTemplateElement that contains the children that should execute.
  `handler` - The ContentHandler to where the result events should be fed.
Throws:
  `TransformerException`
Usage:
  **For advanced use only**

#### processSortKeys

    public java.util.Vector processSortKeys(ElemForEach foreach,
                                   int sourceNodeContext)
                                     throws TransformerException

Get the keys for the xsl:sort elements. Note: Should this go into ElemForEach?

Parameters:
  `foreach` - Valid ElemForEach element, not null.
  `sourceNodeContext` - The current node context in the source tree, needed to evaluate the Attribute Value Templates.
Returns:
  A Vector of NodeSortKeys, or null.
Throws:
  `TransformerException`
Usage:
  **For advanced use only**

#### getElementCallstack

    public java.util.Vector getElementCallstack()

Get the stack of ElemTemplateElements.

Returns:
  A copy of stack that contains the xsl element instructions, the earliest called in index zero, and the latest called in index size()-1.

#### getCurrentTemplateElementsCount

    public int getCurrentTemplateElementsCount()

Get the count of how many elements are active.

Returns:
  The number of active elements on the currentTemplateElements stack.

#### getCurrentTemplateElements

    public ObjectStack getCurrentTemplateElements()

Get the count of how many elements are active.

Returns:
  The number of active elements on the currentTemplateElements stack.

#### pushElemTemplateElement

    public void pushElemTemplateElement(ElemTemplateElement elem)

Push the current template element.

Parameters:
  `elem` - The current ElemTemplateElement (may be null, and then set via setCurrentElement).

#### popElemTemplateElement

    public void popElemTemplateElement()

Pop the current template element.

#### setCurrentElement

    public void setCurrentElement(ElemTemplateElement e)

Set the top of the current template elements stack.

Parameters:
  `e` - The current ElemTemplateElement about to be executed.

#### getCurrentElement

    public ElemTemplateElement getCurrentElement()

Retrieves the current ElemTemplateElement that is being executed.

Returns:
  The current ElemTemplateElement that is executing, should not normally be null.

#### getCurrentNode

    public int getCurrentNode()

This method retrieves the current context node in the source tree.

Returns:
  The current context node (should never be null?).

#### getTemplateCallstack

    public java.util.Vector getTemplateCallstack()

Get the call stack of xsl:template elements.

Returns:
  A copy of stack that contains the xsl:template (ElemTemplate) instructions, the earliest called in index zero, and the latest called in index size()-1.

#### getCurrentTemplate

    public ElemTemplate getCurrentTemplate()

This method retrieves the xsl:template that is in effect, which may be a matched template or a named template.

Please note that the ElemTemplate returned may be a default template, and thus may not have a template defined in the stylesheet.

Returns:
  The current xsl:template, should not be null.

#### pushPairCurrentMatched

    public void pushPairCurrentMatched(ElemTemplateElement template,
                              int child)

Push both the current xsl:template or xsl:for-each onto the stack, along with the child node that was matched. (Note: should this only be used for xsl:templates?? -sb)

Parameters:
  `template` - xsl:template or xsl:for-each.
  `child` - The child that was matched.

#### popCurrentMatched

    public void popCurrentMatched()

Pop the elements that were pushed via pushPairCurrentMatched.

#### getMatchedTemplate

    public ElemTemplate getMatchedTemplate()

This method retrieves the xsl:template that was matched. Note that this may not be the same thing as the current template (which may be from getCurrentElement()), since a named template may be in effect.

Returns:
  The pushed template that was pushed via pushPairCurrentMatched.

#### getMatchedNode

    public int getMatchedNode()

Retrieves the node in the source tree that matched the template obtained via getMatchedTemplate().

Returns:
  The matched node that corresponds to the match attribute of the current xsl:template.

#### getContextNodeList

    public DTMIterator getContextNodeList()

Get the current context node list.

Returns:
  A reset clone of the context node list.

#### getTransformer

    public Transformer getTransformer()

Get the TrAX Transformer object in effect.

Returns:
  This object.

#### setStylesheet

    public void setStylesheet(StylesheetRoot stylesheetRoot)

Set the stylesheet for this processor. If this is set, then the process calls that take only the input .xml will use this instead of looking for a stylesheet PI. Also, setting the stylesheet is needed if you are going to use the processor as a SAX ContentHandler.

Parameters:
  `stylesheetRoot` - A non-null StylesheetRoot object, or null if you wish to clear the stylesheet reference.

#### getStylesheet

    public final StylesheetRoot getStylesheet()

Get the current stylesheet for this processor.

Returns:
  The stylesheet that is associated with this transformer.

#### getQuietConflictWarnings

    public boolean getQuietConflictWarnings()

Get quietConflictWarnings property. If the quietConflictWarnings property is set to true, warnings about pattern conflicts won't be printed to the diagnostics stream.

Returns:
  True if this transformer should not report template match conflicts.

#### setQuietConflictWarnings

    public void setQuietConflictWarnings(boolean b)

If the quietConflictWarnings property is set to true, warnings about pattern conflicts won't be printed to the diagnostics stream. False by default. (Currently setting this property will have no effect.)

Parameters:
  `b` - true if conflict warnings should be suppressed.

#### setXPathContext

    public void setXPathContext(XPathContext xcontext)

Set the execution context for XPath.

Parameters:
  `xcontext` - A non-null reference to the XPathContext associated with this transformer.
Usage:
  **For internal use only**

#### getXPathContext

    public final XPathContext getXPathContext()

Get the XPath context associated with this transformer.

Returns:
  The XPathContext reference, never null.

#### getStackGuard

    public StackGuard getStackGuard()

Get the object used to guard the stack from recursion.

Returns:
  The StackGuard object, which should never be null.
Usage:
  **For internal use only**

#### getRecursionLimit

    public int getRecursionLimit()

Get the recursion limit. Used for infinite loop check. If the value is -1, do not check for infinite loops. Anyone who wants to enable that check should change the value of this variable to be the level of recursion that they want to check. Be careful setting this variable, if the number is too low, it may report an infinite loop situation, when there is none. Post version 1.0.0, we'll make this a runtime feature.

Returns:
  The limit on recursion, or -1 if no check is to be made.

#### setRecursionLimit

    public void setRecursionLimit(int limit)

Set the recursion limit. Used for infinite loop check. If the value is -1, do not check for infinite loops. Anyone who wants to enable that check should change the value of this variable to be the level of recursion that they want to check. Be careful setting this variable, if the number is too low, it may report an infinite loop situation, when there is none. Post version 1.0.0, we'll make this a runtime feature.

Parameters:
  `limit` - A number that represents the limit of recursion, or -1 if no checking is to be done.

#### getResultTreeHandler

    public SerializationHandler getResultTreeHandler()

Get the SerializationHandler object.

Returns:
  The current SerializationHandler, which may not be the main result tree manager.

#### getSerializationHandler

    public SerializationHandler getSerializationHandler()

Get the SerializationHandler object.

Returns:
  The current SerializationHandler, which may not be the main result tree manager.

#### getKeyManager

    public KeyManager getKeyManager()

Get the KeyManager object.

Returns:
  A reference to the KeyManager object, which should never be null.

#### isRecursiveAttrSet

    public boolean isRecursiveAttrSet(ElemAttributeSet attrSet)

Check to see if this is a recursive attribute definition.

Parameters:
  `attrSet` - A non-null ElemAttributeSet reference.
Returns:
  true if the attribute set is recursive.

#### pushElemAttributeSet

    public void pushElemAttributeSet(ElemAttributeSet attrSet)

Push an executing attribute set, so we can check for recursive attribute definitions.

Parameters:
  `attrSet` - A non-null ElemAttributeSet reference.

#### popElemAttributeSet

    public void popElemAttributeSet()

Pop the current executing attribute set.

#### getCountersTable

    public CountersTable getCountersTable()

Get the table of counters, for optimized xsl:number support.

Returns:
  The CountersTable, never null.

#### currentTemplateRuleIsNull

    public boolean currentTemplateRuleIsNull()

Tell if the current template rule is null, i.e. if we are directly within an apply-templates. Used for xsl:apply-imports.

Returns:
  True if the current template rule is null.

#### pushCurrentTemplateRuleIsNull

    public void pushCurrentTemplateRuleIsNull(boolean b)

Push true if the current template rule is null, false otherwise.

Parameters:
  `b` - True if the we are executing an xsl:for-each (or xsl:call-template?).

#### popCurrentTemplateRuleIsNull

    public void popCurrentTemplateRuleIsNull()

Push true if the current template rule is null, false otherwise.

#### pushCurrentFuncResult

    public void pushCurrentFuncResult(java.lang.Object val)

Push a funcion result for the currently active EXSLT `func:function`.

Parameters:
  `val` - the result of executing an EXSLT `func:result` instruction for the current `func:function`.

#### popCurrentFuncResult

    public java.lang.Object popCurrentFuncResult()

Pops the result of the currently active EXSLT `func:function`.

Returns:
  the value of the `func:function`

#### currentFuncResultSeen

    public boolean currentFuncResultSeen()

Determines whether an EXSLT `func:result` instruction has been executed for the currently active EXSLT `func:function`.

Returns:
  `true` if and only if a `func:result` instruction has been executed

#### getMsgMgr

    public MsgMgr getMsgMgr()

Return the message manager.

Returns:
  The message manager, never null.

#### setErrorListener

    public void setErrorListener(ErrorListener listener)
                          throws java.lang.IllegalArgumentException

Set the error event listener.

Specified by:
  `setErrorListener` in class `Transformer`
Parameters:
  `listener` - The new error listener.
Throws:
  `java.lang.IllegalArgumentException` - if

#### getErrorListener

    public ErrorListener getErrorListener()

Get the current error event handler.

Specified by:
  `getErrorListener` in class `Transformer`
Returns:
  The current error handler, which should never be null.

#### getTraceManager

    public TraceManager getTraceManager()

Get an instance of the trace manager for this transformation. This object can be used to set trace listeners on various events during the transformation.

Returns:
  A reference to the TraceManager, never null.

#### getFeature

    public boolean getFeature(java.lang.String name)
                       throws SAXNotRecognizedException,
                              SAXNotSupportedException

Look up the value of a feature.

The feature name is any fully-qualified URI. It is possible for an TransformerFactory to recognize a feature name but to be unable to return its value; this is especially true in the case of an adapter for a SAX1 Parser, which has no way of knowing whether the underlying parser is validating, for example.

### Open issues:

#### Should getFeature be changed to hasFeature?

  Keith Visco writes: Should getFeature be changed to hasFeature? It returns a boolean which indicated whether the "state" of feature is "true or false". I assume this means whether or not a feature is supported? I know SAX is using "getFeature", but to me "hasFeature" is cleaner.

Parameters:
  `name` - The feature name, which is a fully-qualified URI.
Returns:
  The current state of the feature (true or false).
Throws:
  `SAXNotRecognizedException` - When the TransformerFactory does not recognize the feature name.
  `SAXNotSupportedException` - When the TransformerFactory recognizes the feature name but cannot determine its value at this time.
  `SAXNotRecognizedException`
  `SAXNotSupportedException`

#### getMode

    public QName getMode()

NEEDSDOC Method getMode NEEDSDOC (getMode) @return

#### pushMode

    public void pushMode(QName mode)

NEEDSDOC Method pushMode NEEDSDOC @param mode

#### popMode

    public void popMode()

NEEDSDOC Method popMode

#### runTransformThread

    public void runTransformThread(int priority)

Called by SourceTreeHandler to start the transformation in a separate thread NEEDSDOC @param priority

#### runTransformThread

    public void runTransformThread()

Called by this.transform() if isParserEventsOnMain()==false. Similar with runTransformThread(), but no priority is set and setTransformThread is not set.

#### runTransformThread

    public static void runTransformThread(java.lang.Runnable runnable)

Called by CoRoutineSAXParser. Launches the CoroutineSAXParser in a thread, and prepares it to invoke the parser from that thread upon request.

#### waitTransformThread

    public void waitTransformThread()
                             throws SAXException

Used by SourceTreeHandler to wait until the transform completes

Throws:
  `SAXException`

#### getExceptionThrown

    public java.lang.Exception getExceptionThrown()

Get the exception thrown by the secondary thread (normally the transform thread).

Returns:
  The thrown exception, or null if no exception was thrown.

#### setExceptionThrown

    public void setExceptionThrown(java.lang.Exception e)

Set the exception thrown by the secondary thread (normally the transform thread).

Parameters:
  `e` - The thrown exception, or null if no exception was thrown.

#### setSourceTreeDocForThread

    public void setSourceTreeDocForThread(int doc)

This is just a way to set the document for run().

Parameters:
  `doc` - A non-null reference to the root of the tree to be transformed.

#### setXMLSource

    public void setXMLSource(Source source)

Set the input source for the source tree, which is needed if the parse thread is not the main thread, in order for the parse thread's run method to get to the input source.

Parameters:
  `source` - The input source for the source tree.

#### isTransformDone

    public boolean isTransformDone()

Tell if the transform method is completed.

Returns:
  True if transformNode has completed, or an exception was thrown.

#### setIsTransformDone

    public void setIsTransformDone(boolean done)

Set if the transform method is completed.

Parameters:
  `done` - True if transformNode has completed, or an exception was thrown.

#### run

    public void run()

Run the transform thread.

Specified by:
  `run` in interface `java.lang.Runnable`

#### getSnapshot

    public TransformSnapshot getSnapshot()

Deprecated. This is an internal tooling API that nobody seems to be using
This will get a snapshot of the current executing context

Returns:
  TransformSnapshot object, snapshot of executing context

#### executeFromSnapshot

    public void executeFromSnapshot(TransformSnapshot ts)
                             throws TransformerException

Deprecated. This is an internal tooling API that nobody seems to be using
This will execute the following XSLT instructions from the snapshot point, after the stylesheet execution context has been reset from the snapshot point.

Parameters:
  `ts` - The snapshot of where to start execution
Throws:
  `TransformerException`

#### resetToStylesheet

    public void resetToStylesheet(TransformSnapshot ts)

Deprecated. This is an internal tooling API that nobody seems to be using
This will reset the stylesheet execution context from the snapshot point.

Parameters:
  `ts` - The snapshot of where to start execution

#### stopTransformation

    public void stopTransformation()

NEEDSDOC Method stopTransformation

#### getShouldStripSpace

    public short getShouldStripSpace(int elementHandle,
                            DTM dtm)

Test whether whitespace-only text nodes are visible in the logical view of `DTM`. Normally, this function will be called by the implementation of `DTM`; it is not normally called directly from user code.

Specified by:
  `getShouldStripSpace` in interface `DTMWSFilter`
Parameters:
  `elementHandle` - int Handle of the element.
Returns:
  one of NOTSTRIP, STRIP, or INHERIT.

#### init

    public void init(ToXMLSAXHandler h,
            Transformer transformer,
            ContentHandler realHandler)

Initializer method.

Parameters:
  `transformer` - non-null transformer instance
  `realHandler` - Content Handler instance

#### setSerializationHandler

    public void setSerializationHandler(SerializationHandler xoh)

#### fireGenerateEvent

    public void fireGenerateEvent(int eventType,
                         char[] ch,
                         int start,
                         int length)

Fire off characters, cdate events.

Specified by:
  `fireGenerateEvent` in interface `SerializerTrace`
Parameters:
  `eventType` - One of the EVENTTYPE_XXX constants.
  `ch` - The char array from the SAX event.
  `start` - The start offset to be used in the char array.
  `length` - The end offset to be used in the chara array.
See Also:
  `SerializerTrace.fireGenerateEvent(int, char[], int, int)`

#### fireGenerateEvent

    public void fireGenerateEvent(int eventType,
                         java.lang.String name,
                         Attributes atts)

Fire off startElement, endElement events.

Specified by:
  `fireGenerateEvent` in interface `SerializerTrace`
Parameters:
  `eventType` - One of the EVENTTYPE_XXX constants.
  `name` - The name of the element.
  `atts` - The SAX attribute list.
See Also:
  `SerializerTrace.fireGenerateEvent(int, String, Attributes)`

#### fireGenerateEvent

    public void fireGenerateEvent(int eventType,
                         java.lang.String name,
                         java.lang.String data)

Fire off processingInstruction events.

Specified by:
  `fireGenerateEvent` in interface `SerializerTrace`
Parameters:
  `eventType` - One of the EVENTTYPE_XXX constants.
  `name` - The name of the processing instruction.
  `data` - The processing instruction data.
See Also:
  `SerializerTrace.fireGenerateEvent(int, String, String)`

#### fireGenerateEvent

    public void fireGenerateEvent(int eventType,
                         java.lang.String data)

Fire off comment and entity ref events.

Specified by:
  `fireGenerateEvent` in interface `SerializerTrace`
Parameters:
  `eventType` - One of the EVENTTYPE_XXX constants.
  `data` - The comment or entity ref data.
See Also:
  `SerializerTrace.fireGenerateEvent(int, String)`

#### fireGenerateEvent

    public void fireGenerateEvent(int eventType)

Fire off startDocument, endDocument events.

Specified by:
  `fireGenerateEvent` in interface `SerializerTrace`
Parameters:
  `eventType` - One of the EVENTTYPE_XXX constants.
See Also:
  `SerializerTrace.fireGenerateEvent(int)`

#### hasTraceListeners

    public boolean hasTraceListeners()

Description copied from interface: `SerializerTrace`
Tell if trace listeners are present.

Specified by:
  `hasTraceListeners` in interface `SerializerTrace`
Returns:
  True if there are trace listeners
See Also:
  `SerializerTrace.hasTraceListeners()`

#### getDebug

    public boolean getDebug()

#### setDebug

    public void setDebug(boolean b)

#### getIncremental

    public boolean getIncremental()

Returns:
  Incremental flag

#### getOptimize

    public boolean getOptimize()

Returns:
  Optimization flag

#### getSource_location

    public boolean getSource_location()

Returns:
  Source location flag